program cross

!  use dcl_defval
!  use dcl_arrayval
!  use dcl_read_name
!  use dcl_alloc
  use Derivation
  use max_min
  use file_operate
  use typhoon_analy
  use math_const
!  use gtool_history
  use Thermo_Function
  use Basis
  use Statistics

  implicit none

!  2 ι͵ٲʬۤѤ, Yang et al. (2013) μˡ˴Ť
!  ¿ɱȽꤹץ. 
!  ̤ 1 եλƥȷǳƻȽ, 
!  ¦ɱȾ, moat , ¦ɱϤ. 
!  ɲþȤ, ¿ɱο˴ؤ餺, Ʊ̳ 8 ΰǤ
!  ʿѵٲ٤ɸкư, ʬۤȤ NetCDF ǽϤ.
!  ե̾ header + ѿ̾ + footer + '.CE.nc' ν
!  * 濴 ".tcenter" եɤ߹.
!  * ϥե d2valc ǻ.
!  * nnx(1) = 1 Ǹ, nnx(2) = ΰǱ
!  * axopt  'll' ꤹ, ٷٺɸǷ׻.

  integer, parameter :: tccol=3   ! .tcenter ǡ
  integer, parameter :: nsec=8     ! ȽƱ̳ʬ
  integer :: i, j, k, id, it, m, stat, minnx,minny, nr, ntz, nt, nl, i_time
  integer :: ijudge, icrit4
  integer :: nx, ny
  integer, dimension(2) :: nnx, nny
  real, parameter :: undef=-999.0
  real :: undefc, dmoat, dinner, douter
  real :: min_val, posi, dx, dy
  real, dimension(nsec) :: tsec
  real, allocatable, dimension(:) :: x, y
  real, allocatable, dimension(:,:) :: val2
  real, allocatable, dimension(:,:) :: tbbr, tbbsig
  real, allocatable, dimension(:) :: theta, r, ttime  ! tangential mean 
  character(200) :: input_fname, output_fname, listname
  character(8) :: tname, ccrit1, ccrit2, ccrit3
  character(2) :: axopt
  character(1), dimension(3) :: dimname, unitname
  character(12), dimension(3) :: lname
  character(200), allocatable, dimension(:,:) :: cval
  logical :: stdflag, ljudge, lcrit4
  logical, dimension(8) :: lcrit1, lcrit2, lcrit3
!  type(GT_HISTORY) :: w_hst

!  namelist /ncval /axopt, undefc
  namelist /input /nx, ny, dx, dy, listname, nnx, nny, undefc
!  read(5,nml=ncval)
  read(5,nml=input)
  if(undefc==0.0e0)then
     write(*,*) "*** WARNING (main) *** : namelist (undefc) is not set."
  end if

  allocate(x(nx))
  allocate(y(nx))
  allocate(val2(nx,ny))

  x=(/((dx*real(i-1)),i=1,nx)/)
  y=(/((dy*real(i-1)),i=1,ny)/)

!  call dcl_read_nml( stat )
!  call dcl_alloc_val( stat )
!  call dcl_pointdef( stat )

!-- ѿν

  stdflag=.true.

  if(stdflag.eqv..true.)then
     write(*,*) "### MESSAGE (main) ### : "
     write(*,*) "In interpolation routines, stdopt is set as true."
     write(*,*) "This means that error is not output."
  end if

!  dimname=(/'r', 's', 't'/)
!  lname=(/'Radius', 'Angle ', 'Time  '/)
!  unitname=(/'m', '1', 's'/)

  nr=nnx(2)-nnx(1)+1
!  tsec=(/((real(i)),i=1,nsec)/)

  allocate(r(nr))
  allocate(tbbr(nr,nsec))
  allocate(tbbsig(nr,nsec))

!-- r-theta Ϥκɸѿ

!  if(axopt(1:2)=='ll')then
!     do i=1,nx
!        x(i)=x(i)*pi/180.0
!     end do
!     do j=1,ny
!        y(j)=y(j)*pi/180.0
!     end do
!     do j=1, nr
!        r(j)=radius*(y(j)-y(1))
!     end do
!  else if(axopt(1:2)=='xy')then
     do j=1, nr
        r(j)=x(j)-x(1)
     end do
!  else
!     write(*,*) "*** MESSAGE (main) *** : axopt is not set. STOP."
!     stop
!  end if

  nt=int(2.0*pi*r(nr)/(r(2)-r(1)))

  allocate(theta(nt))

  do j=1,nt
     theta(j)=2.0*pi*real(j-1)/real(nt-1)
  end do

!-- grdname + ".tcenter" Ϸǡɤ߹

  nl=line_number_counter( trim(adjustl(listname)) )
!  nl=line_number_counter( trim(grdname)//'.tcenter' )-2

  allocate(cval(tccol,nl))
!  allocate(ttime(nl))

  call read_file_text( trim(adjustl(listname)), tccol, nl, cval )
!  call read_file_text( trim(grdname)//'.tcenter', tccol, nl, cval, skip=2 )
!  do i=1,nl
!     ttime(i)=c2r_convert( trim(adjustl(cval(1,i))) )
!  end do

!-- gtool եν

!  output_fname=trim(hname)//'.tbb'//trim(footname)//'.CE.nc'

!  call HistoryCreate( &       ! ҥȥ꡼, ñե
!  &    file=trim(adjustl(output_fname)),  &
!  &    title='Brightness temperatures for 8 sections', &
!  &    source='test',   &
!  &    institution='',       &
!  &    dims=(/dimname(1), dimname(2), dimname(3) /),  &
!  &    dimsizes=(/nr,nsec,0/),  &
!  &    longnames=(/lname(1), lname(2), lname(3) /),  &
!  &    units=(/unitname(1), unitname(2), unitname(3) /),  &
!  &    origin=real(ininame), interval=real(dt) )

!  call HistoryAddVariable( &                   ! ѿ
!  &    varname='tbbr',  &
!  &    dims=(/dimname(1), dimname(2), dimname(3)/),  &
!  &    longname='Mean Tbbs in 8 sections',  &
!  &    units='K', xtype='float')

!  call HistoryAddVariable( &                   ! ѿ
!  &    varname='tbbsig',  &
!  &    dims=(/dimname(1), dimname(2), dimname(3)/),  &
!  &    longname='Stand. Dev. of Tbbs in 8 sections',  &
!  &    units='K', xtype='float')

!  call HistoryAddAttr( 'tbbr', '+missing_value', undef )

  !-- gtool κɸ˽
!  call HistoryPut( dimname(1), r )                 ! ѿ
!  call HistoryPut( dimname(2), tsec(1:nsec) )  ! ѿ

!  open(unit=100,file=trim(hname)//'.tbb'//trim(footname)//'.CE.txt',  &
  open(unit=100,file=trim(listname)//'.CE.txt',  &
  &    status='unknown')

  write(100,'(a102)') "'Time'            'Y' 'D-moat'        'R-inner'       'D-outer'       "//  &
  &                   "'CRIT1'   'CRIT2'   'CRIT3'   'C4'"
  write(100,'(a102)') "'s'               '1' 'm'             'm'             'm'             "//  &
  &                   " YYYYYYYY  YYYYYYYY  YYYYYYYY '1' "

!-- ȯŸ

!  do i=ininame,ininame+(fnumber-1)*dt,dt
  do i=1,nl
!     write(tname,'(i8.8)') i
!     it=(i-ininame)/dt
!     input_fname=trim(hname)//tname//trim(footname)    ! ʸĹΤޤζ, trim 
      input_fname=trim(adjustl(cval(1,i)))
write(*,*) input_fname

     call read_file( trim(adjustl(input_fname)), nx, ny, 1, val2 )
!     call auto_read_file( trim(input_fname), val2d+val2ad, val3d+val3ad,  &
!   &                      d2valc, d3valc, ad2valc, ad3valc, nx, ny, nz,  &
!   &                      val2, val3 )

!-- ̤ͤ CReSS Ѥͤ DCL Ѥͤѹ

     do j=1,ny
        do id=1,nx
           if(val2(id,j)==undefc)then
              val2(id,j)=undef
           end if
        end do
     end do

!-- 濴

!     call interpo_search_1d( ttime, real(i), i_time )

!     minnx=c2i_convert( trim(adjustl(cval(14,i_time))) )
!     minny=c2i_convert( trim(adjustl(cval(15,i_time))) )
     minnx=c2i_convert( trim(adjustl(cval(2,i))) )
     minny=c2i_convert( trim(adjustl(cval(3,i))) )

!-- Ƚ곫 ---

     call DCE_Yang( x, y, x(minnx), y(minny), r, theta,  &
  &                 val2, ljudge, tbbr, tbbsig,  &
  &                 dmoat, dinner, douter,  &
  &                 lcri1=lcrit1, lcri2=lcrit2, lcri3=lcrit3,  &
  &                 lcri4=lcrit4, undef=undef,  &
  &                 undefg=undef, undefgc='err',  &
  &                 axis=axopt(1:2), stdopt=stdflag )

     if(ljudge.eqv..true.)then
        ijudge=1
     else
        ijudge=0
     end if

     do id=1,8
        if(lcrit1(id).eqv..true.)then
           ccrit1(id:id)='1'
        else
           ccrit1(id:id)='0'
        end if
        if(lcrit2(id).eqv..true.)then
           ccrit2(id:id)='1'
        else
           ccrit2(id:id)='0'
        end if
        if(lcrit3(id).eqv..true.)then
           ccrit3(id:id)='1'
        else
           ccrit3(id:id)='0'
        end if
     end do

     if(lcrit4.eqv..true.)then
        icrit4=1
     else
        icrit4=0
     end if

!-- NetCDF եؽ񤭽Ф

!     call HistoryPut( 'tbbr', tbbr(1:nr,1:nsec) )
!     call HistoryPut( 'tbbsig', tbbsig(1:nr,1:nsec) )

!     write(*,*) "Writing the data at ", ttime(i_time), "[s]."

     write(100,'(1PE16.8,i4,1P3E16.8,a30,i4)')  &
  &            real(i), ijudge, dmoat, dinner, douter,  &
  &            ' '//ccrit1(1:8)//' '//ccrit2(1:8)//' '//  &
  &            ccrit3(1:8)//'   ', icrit4

  end do

  close(unit=100)

!  call HistoryClose

end program
